library ieee;
use ieee.std_logic_1164.all;
 
use ieee.numeric_std.all;
use std.textio.all;
use work.all;

entity Thash is 
port ( 
       INxDI:   in std_logic_vector(0 to 31); 
       LBxSI:   in std_logic ; 
 
       ClkxCI:  in std_logic; 
       ResxRBI: in std_logic; 
       HxDO:   out std_logic_vector(0 to 127);  
 
       EHxSO:   out std_logic 
       );
end entity Thash;

architecture tr1 of Thash is

 

 
signal NFSRxDP,NFSRxDN: std_logic_vector(0 to 255); 

 
 
signal StatxDP, StatxDN: std_logic_vector(0 to 1);

signal RoundxDP, RoundxDN: integer range 0 to 1023;

 

signal ABSORBxS, LOADxS,SQUEEZExS : std_logic;

signal INITxD, NEXT_STATExD,MxD,InxD : std_logic_vector(0 to 255); 

 

begin


--------------------------------------------------------------------------------------------------------------
 p_main: process (StatxDP,LBxSI)
  
   begin
   
 
    
   LOADxS 	<= '0';

   SQUEEZExS 	<= '0';
   StatxDN <= StatxDP;
 
   case StatxDP is 
   when "00" =>     LOADxS  <= '1';
   --------------------------------------------------
                    StatxDN  <= "01"; 

   when "01" =>     if LBxSI = '1' then
                   
                    StatxDN  <="10";
                    else
                   
		    StatxDN  <="01";
                    end if;

   
  when "10" =>     StatxDN <= StatxDP;  SQUEEZExS<='1'; 

 when others => StatxDN <= StatxDP;   LOADxS  <= '0';
 end case;
   
end process p_main;
 
 r_main: process (RoundxDP)
 begin
 case RoundxDP is
 when 1023 => RoundxDN<=0;
 when others => RoundxDN <= RoundxDP+1;
 end case;
 end process r_main;

ABSORBxS<= '1' when RoundxDP=0 and (StatxDP/="10") else '0';
--------------------------------------------------------------------------------------------------------------
 
  
           
INITxD <=    x"00000000000000000000" & x"b7e151628ae243f6a8885a" & x"0000000000000000000000";
 
uf01: entity ufunc (uf) port map (NFSRxDP, NEXT_STATExD ); 

a1: for i in 0 to 31 generate
InxD (i) <= MxD(i) xor (ABSORBxS and InxDI(i) );
end generate a1;

InxD(32 to 255)<=  MxD(32 to 255 );

 
 

 

  a0: for i in 0 to 15 generate 
      b0: for j in   0 to 7 generate
 
        HxDO(8*i+j) <= NEXT_STATExD(120-8*i+ j);
    end generate b0;
 end generate a0;

 

 
EHxSO <= '1' when SQUEEZExS = '1' and RoundxDP=0 else '0';  

MxD <= INITxD when LOADxS = '1' else NEXT_STATExD;
--------------------------------------------------------------------------------------------------------------
  
--------------------------------------------------------------------------------------------------------------
 
nr1: entity Sreg (sr) port map (InxD,ClkxCI, NFSRxDP);

-------------------------------------------------------------------------------------------------------------- 

-------------------------------------------------------------------------------------------------------------- 
  p_clk: process (ResxRBI, ClkxCI)
         begin
           if ResxRBI='0' then
                   RoundxDP  <= 0;
                   StatxDP   <= (others => '0') ;
           
	     
           elsif ClkxCI'event and ClkxCI ='1' then

		   RoundxDP  <= RoundxDN;
                   StatxDP   <= StatxDN;
  
           end if;
         end process p_clk;








end architecture tr1;

