------------------------------------------------------------------------------- 

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;
use ieee.numeric_std.all;
use std.textio.all;
use ieee.std_logic_textio.all;
--use work.aes_pack.all;

entity thash_tb is
end thash_tb;


architecture tb of thash_tb is   

 
signal INxD :    std_logic_vector(0 to 31);
signal LBxS :    std_logic ;

 
signal ClkxC:    std_logic; 
signal ResxRB:   std_logic; 
signal HxD:     std_logic_vector(0 to 127);  
 
 
signal EHxS:     std_logic;

 
 

  component Thash
  port(
       INxDI:   in std_logic_vector(0 to 31); 
       LBxSI:   in std_logic ;  
       ClkxCI:  in std_logic; 
       ResxRBI: in std_logic; 
       HxDO:   out std_logic_vector(0 to 127);  
       EHxSO:   out std_logic
       );
 
  end component;
       


   
begin

  -- Instantiate the module under test (MUT)
  mut: Thash
    port map (
 
	INxDI=> INxD,
	LBxSI=> LBxS,
        ClkxCI => ClkxC,
        ResxRBI=> ResxRB,
	HxDO=> HxD,
        EHxSO=> EHxS 
 
  );

  -- Generate the clock
--  ClkxC <= not (ClkxC) after clkphasehigh;


  Tb_clkgen : process
  begin
     ClkxC <= '1';
     wait for 50 ns;
     ClkxC <= '0';
     wait for 50 ns;
  end process Tb_clkgen;

  -- obtain stimulus and apply it to MUT
  ----------------------------------------------------------------------------
  B1 : block
   begin


  -- timing of clock and simulation events
 


  Tb_stimappli : process
    variable INLine   : line;
    variable temp_k   : STD_LOGIC_VECTOR(0 to 127);
    variable temp_p   : STD_LOGIC_VECTOR(0 to 95); 
    variable temp_t   : STD_LOGIC_VECTOR(0 to 32767);
    variable temp_a   : STD_LOGIC_VECTOR(0 to 32767); 
    variable temp_len : integer range 0 to 4096;  
    variable tempa_len : integer range 0 to 128;
    variable int_len,blen,bool,hlen :  integer range 0 to 32767;
    variable inta_len,balen :  integer range 0 to 8;
    variable rem_len,rema_len : integer range 0 to 15;
 
    constant clkphasehigh: time:= 50 ns;
    constant clkphaselow: time:= 50 ns;
     constant clkper: time:= 100 ns;
    constant resetactivetime:         time:= 25 ns;

 
 

  file INPUT_file,keyfile,ivfile,adfile,ptfile,ladfile,lptfile : TEXT;



  begin
    -- Opening Input File
 
    file_open(ptfile,  "PT.txt", read_mode);
 
    -- default values

    -- Reset phase
    -- Reset is active 
    ResxRB      <= '0';
    
    INxD <=  (others => '0');
    LBxS <=  '0';
    wait for resetactivetime;
    ResxRB      <= '1';

    -- process until we run out of stimuli

    appli_loop : while not (endfile(ptfile)) loop
   
 



    
    readline(ptfile,INLine);
    blen := INLine'length;
    hlen := blen/8;
    hread(INLine,temp_a);
 
    
    for lv in 1 to hlen loop
       

           INxD<= temp_a(32*lv-32 to 32*lv-32+31);
 
           
       
           if lv = hlen then 
             LBxS <= '1';
           else
              LBxS <= '0';
           end if;

           
           wait for clkper;
 
       
        
    end loop;

    wait for 2*clkper-resetactivetime;
    ResxRB      <= '0';
    wait for resetactivetime;
    ResxRB      <= '1';

    end loop appli_loop;
    wait until ClkxC'event and ClkxC = '1';
    file_close(ptfile);
    wait;
  end process Tb_stimappli;
end block;
end tb;

