library ieee;
use ieee.std_logic_1164.all;
 
use ieee.numeric_std.all;
use std.textio.all;
use work.all;

entity Triad is 
port ( KeyxDI : in std_logic_vector(0 to 127); 
       IVxDI:   in std_logic_vector(0 to 95);
       INxDI:   in std_logic; 
       CSxDI:   in std_logic_vector(0 to 1); 
       ClkxCI:  in std_logic; 
       ResxRBI: in std_logic; 
       CTxDO:   out std_logic;  
       TagxDO:  out std_logic;
       ECxSO:   out std_logic;   
       ETxSO:   out std_logic
       );
end entity Triad;

architecture tr1 of Triad is

 

 
signal NFSRxDP,NFSRxDN: std_logic_vector(0 to 255); 

 
 
signal StatxDP, StatxDN: std_logic_vector(0 to 1);

 

signal T1xD,T2xD,T3xD,APxD,InxD,ZxD: std_logic;

signal MACxS, KLOADxS : std_logic;

signal INITxD, NEXT_STATExD : std_logic_vector(0 to 255); 

 

begin


--------------------------------------------------------------------------------------------------------------
 p_main: process (StatxDP, CSxDI)
  
   begin
   
 
   
   --CLAxDN <= CLAxDP;
   --CLPxDN <= CLPxDP;
 
   KLOADxS 	<= '0';
   MACxS 	<= '0';
   StatxDN <= StatxDP;
 
   case StatxDP is 
   when "00" =>     KLOADxS  <= '1';
   --------------------------------------------------
                    StatxDN  <= "01"; 

   when "01" =>     if CSxDI = "10" then
                    KLOADxS  <= '1';
                    StatxDN  <="10";
                    else
                    KLOADxS  <= '0';
		    StatxDN  <="01";
                    end if;
                    MACxS <= '1';
   
  when "10" =>     StatxDN <= StatxDP; KLOADxS  <= '0';

 when others => StatxDN <= StatxDP;  KLOADxS  <= '0';
 end case;
   
end process p_main;
 
 
--------------------------------------------------------------------------------------------------------------
 
 

--INITxD <=  IVxDI(88 to 95)    & KeyxDI(88 to 95) & x"ff" & KeyxDI(96 to 103) & x"ff" & KeyxDI(104 to 111) & x"ff" & KeyxDI(112 to 119) & x"fe" & KeyxDI(120 to 127) &
--           IVxDI(0  to 87)    &
--           KeyxDI(0 to 87)    ;
           
INITxD <=   IVxDI(0 to 7)      & KeyxDI(32 to 39) & x"ff" & KeyxDI(24 to 31) & x"ff" & KeyxDI(16 to 23) & x"ff" & KeyxDI(8 to 15) & x"fe" & KeyxDI(0 to 7) &

            IVxDI(88  to 95)    & IVxDI(80  to 87)   & IVxDI(72  to 79)   & IVxDI(64  to 71)  & IVxDI(56  to 63)  & IVxDI(48  to 55)  & IVxDI(40  to 47)  &
            IVxDI(32  to 39)    & IVxDI(24  to 31)   & IVxDI(16  to 23)   & IVxDI(8  to 15)   &

            KeyxDI(120 to 127)  & KeyxDI(112 to 119) & KeyxDI(104 to 111) & KeyxDI(96 to 103) & KeyxDI(88 to 95)  & KeyxDI(80 to 87)  & KeyxDI(72 to 79) & KeyxDI(64 to 71)  &
            KeyxDI(56 to 63)    & KeyxDI(48 to 55)   & KeyxDI(40 to 47)   ;
 
uf01: entity ufunc (uf) port map (NFSRxDP, NEXT_STATExD, InxD, ZxD); 

 
InxD <= InxDI and MACxS;
 

 


CTxDO  <=  ZxD xor INxDI;
TagxDO <=  ZxD;

ECxSO <= '1' when StatxDP="10" and (CSxDI = "01" or CSxDI="10") else '0';
ETxSO <= '1' when StatxDP="01" and (CSxDI = "01" or CSxDI="10") else '0';  
 
--------------------------------------------------------------------------------------------------------------
  
--------------------------------------------------------------------------------------------------------------
 
nr1: entity Sreg (sr) port map (NEXT_STATExD , INITxD , KLOADxS,ClkxCI, NFSRxDP);

-------------------------------------------------------------------------------------------------------------- 

-------------------------------------------------------------------------------------------------------------- 
  p_clk: process (ResxRBI, ClkxCI)
         begin
           if ResxRBI='0' then
                   --RoundxDP  <= 0;
                   StatxDP   <= (others => '0') ;
           
	     
           elsif ClkxCI'event and ClkxCI ='1' then

		   --RoundxDP  <= RoundxDN;
                   StatxDP   <= StatxDN;
  
           end if;
         end process p_clk;








end architecture tr1;

